//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    1
#property indicator_color1     DeepSkyBlue
#property indicator_width1     2
#property indicator_level1     1.00
#property indicator_levelcolor DimGray


//
//
//
//
//

extern string TimeFrame      = "Current time frame";
extern string Symbols        = "EURUSD;EURJPY;EURCHF;GBPUSD;GBPJPY;USDCHF;USDJPY";
extern int    SmoothLength   = 3;
extern int    SmoothPhase    = 0;
extern bool   UseVolumes     = true;
extern bool   Interpolate    = true;

//
//
//
//
//

double trin[];

//
//
//
//
//

string forSymbols[];
string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,trin); 

   //
   //
   //
   //
   //

      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars"); if (returnBars) return(0);
      
      //
      //
      //
      //
      //
      
         parseSymbols(Symbols,forSymbols);

      //
      //
      //
      //
      //
      
      calculateValue = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      timeFrame      = stringToTimeFrame(TimeFrame);

   //
   //
   //
   //
   //

   string symbolsUsed = ""; for (int i=0; i<ArraySize(forSymbols); i++) symbolsUsed = symbolsUsed+forSymbols[i]+",";
   IndicatorShortName(timeFrameToString(timeFrame)+" "+symbolsUsed);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,y,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { trin[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for (i=0; i<ArraySize(forSymbols); i++)
          limit = MathMax(limit,MathMin(Bars-1,iCustom(forSymbols[i],timeFrame,indicatorFileName,"returnBars",0,0)));
      int count = ArraySize(forSymbols);

      //
      //
      //
      //
      //
      
      for(i=limit; i>=0; i--)
      {
         double advancep = 0;
         double declinep = 0;
         double advancev = 0;
         double declinev = 0;
         double sumw     = 0;
         for (int c=0; c<count; c++) 
            {
               y = iBarShift(forSymbols[c],0,Time[i]);
                  
                  double currPrice  = iClose (forSymbols[c],0,y  );
                  double prevPrice  = iClose (forSymbols[c],0,y+1);
                  double currVolume = iVolume(forSymbols[c],0,y  );
                     if (currPrice>prevPrice) { advancep += 1; advancev += currVolume; }
                     if (currPrice<prevPrice) { declinep += 1; declinev += currVolume; }
            }

         double adpRatio = 0;
            if (declinep == 0) declinep = 1;
            if (declinev == 0) declinev = 1;
            if (advancev == 0) advancev = 1;
               if (UseVolumes)
                     trin[i] = iSmooth((advancep/declinep)/(advancev/declinev),SmoothLength,SmoothPhase,i);
               else  trin[i] = iSmooth((advancep/declinep)                    ,SmoothLength,SmoothPhase,i);
         
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
   
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (i=0; i<ArraySize(forSymbols); i++)
               limit = MathMax(limit,MathMin(Bars-1,iCustom(forSymbols[i],timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));

   //
   //
   //
   //
   //
      
   for (i=limit;i>=0;i--)
   {
      y = iBarShift(NULL,timeFrame,Time[i]);
         trin[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Symbols,SmoothLength,SmoothPhase,UseVolumes,0,y);

         //
         //
         //
         //
         //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
               trin[i+k] = trin[i] + (trin[i+n]-trin[i])*k/n;
   }
   return(0);
}

//+------------------------------------------------------------------
//|                                                                 
//+------------------------------------------------------------------
//
//
//
//
//

void parseSymbols(string from, string& to[])
{
   from = StringTrimLeft(StringTrimRight(from));
   if (StringSubstr(from,StringLen(from),1) != ";")
                    from = StringConcatenate(from,";");

   //
   //
   //
   //
   //                                   
            
   int s = 0;
   int i = StringFind(from,";",s);

   while (i > 0)
   {
       string current = StringSubstr(from,s,i-s);
                         ArrayResize(to,ArraySize(to)+1);
                                     to[ArraySize(to)-1] = current;
       s = i + 1;
       i = StringFind(from,";",s);
   }               
}

//+------------------------------------------------------------------
//|                                                                 
//+------------------------------------------------------------------
//
//
//
//
//

double wrk[][10];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}